// MyListCtrl.cpp : implementation file
//

#include "stdafx.h"
#include "VSGraphxSample.h"
#include "MyListCtrl.h"
#include "EntitiesBar.h"
#include "VSGraphXSampleView.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMyListCtrl

CMyListCtrl::CMyListCtrl()
{
}

CMyListCtrl::~CMyListCtrl()
{
}


BEGIN_MESSAGE_MAP(CMyListCtrl, CListCtrl)
	//{{AFX_MSG_MAP(CMyListCtrl)
	ON_WM_LBUTTONDOWN()
	ON_WM_RBUTTONDOWN()
	ON_WM_KEYUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


//Based on the current selection it updates the view and the entity information
//in the entities bar.
void CMyListCtrl::UpdateSelection()
{
	POSITION pos = GetFirstSelectedItemPosition();

	int nItem = -1;
	if (pos)
		nItem = GetNextSelectedItem(pos);

	CMainFrame *pMainFrm = (CMainFrame *) AfxGetMainWnd();
	if (pMainFrm)
	{
		CVSGraphXSampleView *pView = (CVSGraphXSampleView *) pMainFrm->GetActiveView();
		if (pView)
			pView->SetSelection(nItem);
	}

	CEntitiesBar *pEntitiesBar = ((CEntitiesBar *) GetParent());
	if (pEntitiesBar)
		pEntitiesBar->UpdateInfo(nItem);
}


//Updates the entities list based on a CVSGraphX drawing.
void CMyListCtrl::UpdateList(CVSGraphX *graphx)
{
	DeleteAllItems();
	UpdateSelection();

	if (!graphx)
		return;

	int size = graphx->GetNumOfEntities();

	m_imageList.DeleteImageList();
	m_imageList.Create(24,24,ILC_COLORDDB,size,10);

	for (int i=0;i<size;i++)
	{
		HBITMAP hBmp = graphx->CreateIcon(24,24, i, i);
		m_imageList.Add(CBitmap::FromHandle(hBmp), RGB(0,0,0));
		::DeleteObject(hBmp);
	}

	SetImageList(&m_imageList,LVSIL_SMALL);

	for (i=0;i<size;i++)
	{
		LVITEM lvItem;
		lvItem.mask = LVIF_TEXT | LVIF_IMAGE;
		lvItem.iItem = i;
		lvItem.iImage = i;
		lvItem.iSubItem = 0;

		int type = graphx->GetEntityType(i);
		if (type == VSGRAPHX_ENTITY_POLYBEZIER)
			lvItem.pszText = "PolyBezier Path";
		else if (type == VSGRAPHX_ENTITY_TEXT)
			lvItem.pszText = "Text";
		else if (type == VSGRAPHX_ENTITY_BITMAP)
			lvItem.pszText = "Bitmap";

		InsertItem(&lvItem);
	}

	UpdateSelection();
}

/////////////////////////////////////////////////////////////////////////////
// CMyListCtrl message handlers


void CMyListCtrl::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CListCtrl::OnLButtonDown(nFlags, point);

	UpdateSelection();
}

void CMyListCtrl::OnRButtonDown(UINT nFlags, CPoint point) 
{
	CListCtrl::OnRButtonDown(nFlags, point);

	UpdateSelection();
}

void CMyListCtrl::OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	CListCtrl::OnKeyUp(nChar, nRepCnt, nFlags);

	UpdateSelection();
}

