// VSGraphXSampleView.h : interface of the CVSGraphXSampleView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_VSGRAPHXSAMPLEVIEW_H__F6E27D42_332A_4673_9E0A_D029108C0B89__INCLUDED_)
#define AFX_VSGRAPHXSAMPLEVIEW_H__F6E27D42_332A_4673_9E0A_D029108C0B89__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CVSGraphXSampleDoc;

class CVSGraphXSampleView : public CView
{
protected: // create from serialization only
	CVSGraphXSampleView();
	DECLARE_DYNCREATE(CVSGraphXSampleView)

// Attributes
public:
	CVSGraphXSampleDoc* GetDocument();

	double m_zoomFactor;				//zoom factor for drawing display
	double m_leftSide, m_topSide;		//drawing's left and top side on view

protected:
	int m_selection;	//the index of the selected entity (-1 if no entity selected)
	int m_units;		//the units used in the view
	double m_unitsFactor;	//the units factor for the view

// Operations
public:
	void UpdateScrollBars(int x, int y);
	void SetSelection(int selection);

	int GetUnits();
	CString GetUnitsString();

protected:
	void DrawSelectionRect(CDC *pDC);
	void DrawAxes(CDC *pDC);

	void SetUnits(int units);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CVSGraphXSampleView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual void OnInitialUpdate();
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CVSGraphXSampleView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CVSGraphXSampleView)
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnZoomFit();
	afx_msg void OnZoomIn();
	afx_msg void OnZoomOut();
	afx_msg void OnUnitsCentimeters();
	afx_msg void OnUpdateUnitsCentimeters(CCmdUI* pCmdUI);
	afx_msg void OnUnitsInches();
	afx_msg void OnUpdateUnitsInches(CCmdUI* pCmdUI);
	afx_msg void OnUnitsMillimeters();
	afx_msg void OnUpdateUnitsMillimeters(CCmdUI* pCmdUI);
	afx_msg void OnUnitsTenthsOfMillimeters();
	afx_msg void OnUpdateUnitsTenthsOfMillimeters(CCmdUI* pCmdUI);
	afx_msg void OnUnitsPixels();
	afx_msg void OnUpdateUnitsPixels(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in VSGraphXSampleView.cpp
inline CVSGraphXSampleDoc* CVSGraphXSampleView::GetDocument()
   { return (CVSGraphXSampleDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_VSGRAPHXSAMPLEVIEW_H__F6E27D42_332A_4673_9E0A_D029108C0B89__INCLUDED_)
